2003-06-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.99 released.

2003-06-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* mathlib.h (_GLIBCPP_USE_C99): Define for MingW32.

	* weather_std.C (precipitation_correction_key): New parameter.
	(precipitation_correction_dai): New parameter.
	(precipitation_correction): Removed.
	(read_line): Update caller.
	(initialize): Ditto.
	(WeatherStandard): Ditto.
	(WeatherStandardSyntax): Ditto.

2003-06-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/all.dai: Added dk-horizon.dai.

	* lib/dk-horizon.dai: Updated numbers.

2003-06-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.98 released.

2003-06-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* plf.C (operator ()): Test for ==.

	* time.C (load_syntax): Gave hour a default value of zero.

	* uzlr.C (tick): Remove previous change.

2003-06-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* symbol.h: Port to GCC 3.3.
	* summary_simple.C (summarize): Fixed 3.3 warning.
	* root_system.C (tick_daily): Ditto.

	* Version 2.97 released.

2003-06-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater.h, groundwater.C, groundwater_pipe.C (update_water):
	Removed. 
	* soil_water.C (tick): Update caller.
	* groundwater_pipe.C: Removed unused helper functions.
	
	* uzlr.C (tick): Pre-calculate q_max.

	* denitrification.C, denitrification.h (K_fast): New parameter.

2003-06-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.96 released.

2003-05-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater.h, groundwater_deep.C, groundwater_file.C
	* groundwater_fixed.C, groundwater_lysimeter.C, groundwater_pipe.C
	* groundwater_static.C (tick): New h_surface argument.
	* column_inorganic.C (tick): Update caller.
	* column_std.C (tick): Ditto.

	* uzlr.C (tick): Better handling of lake top.

	* Version 2.95 released.

2003-05-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* uzlr.C (tick): Handle forced_flux.
	* uzrichard.C (richard): Handle forced_flux.

	* uzmodel.h (flux_bottom, is_lysimeter): Removed.
	(type): Added.
	* all: Updated callers and implementers.

	* soil_water.C, soil_water.h (drain): New function.

	* groundwater.h, groundwater_deep.C, groundwater_file.C
	* groundwater_fixed.C, groundwater_lysimeter.C, groundwater_pipe.C
	* groundwater_static.C (tick): New Soil, SoilWater and SoilHeat
	arguments. 
	* column_std.C (tick): Update caller.

2003-05-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.94 released.

2003-05-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/dk-horizon.dai: Updated.

	* groundwater_pipe.C (EquilibriumDrainFlow): Multiply with
	anisotropy. 

2003-05-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C, groundwater.C, groundwater.h (update_water):
	Made 'q_p' and 'h_ice' const. 

2003-05-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.93 released.

2003-05-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C (extra_water_to_surface): New variable.
	(update_water, RaisingGWT): Use it.
	* groundwater.h, groundwater.C, groundwater_pipe.C (update_water):
	Take UZtop and Trelog arguments. 
	* soil_water.C (tick): Update caller.
	
	* Version 2.92 released.

2003-05-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* horizon.C, horizon.h (anisotropy): New parameter.
	* soil.C, soil.h (anisotropy): Distribute it.
	* groundwater_pipe.C (EquilibriumDrainFlow): Use it.

2003-05-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.91 released.

2003-05-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_simple.C (tick): Remove "==> " from messages.
	* phenology_std.C (tick_daily): Ditto.
	* phenology_TSum.C (tick_daily): Ditto.
	* crop_std.C (tick): Ditto.

	* daisy.h, daisy.C (print_time): New parameter.
	* daisy.C (run): Obey it.

	* action_crop.C (output, doIt, harvest, doIt, doIt): Remove brackets.
	* action_tillage.C (doIt): Ditto.
	* action_surface.C (doIt): Ditto.
	* action_spray.C (doIt): Ditto.
	* action_ridge.C (doIt): Ditto.
	* action_sow.C (doIt): Ditto.
	* action_merge.C (doIt): Ditto.
	* action_irrigate.C (doIt) Ditto.
	* action_heat.C (doIt): Ditto.
	* action_harvest.C (doIt): Ditto.
	* action_fertilize.C (doIt): Ditto.
	
	* treelog.h (touch): New abstract function.
	* treelog_dual.C (touch): Implemented it.
	* treelog_stream.C (touch): Ditto.

	* weather.h (daily_max_air_temperatur, daily_min_air_temperatur):
	New abstract functions.
	* weather_hourly.C: Implement them.
	* weather_none.C: Ditto.
	* weather_simple.C: Ditto.
	* weather_std.C: Ditto.

	* Version 2.90 released.

2003-05-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/dk-horizon.dai: Regenerated with new parameters.

2003-05-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.89 released.

2003-05-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* denitrification.C (alpha_fast, water_factor_fast): Changed.
	(redox_height): New parameter.
	(converted_redox): New log variable.
	* lib/log.dai ("Denitrification"): Use it.

	* weather_std.C (read_new_day): Don't throw an exception on
	unmappable dates. 

2003-05-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.88 released.

2003-05-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select_interval.C (output_array): Use Geometry::total (array) if
	possible. 

	* hydraulic_M_vGp.C: New model.

	* harvesting.C (DSnew): Clarified doumentation.

2003-05-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.87 released.

2003-05-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table.C (initial_match, initial_done): Move summary
	initialization to initial_match.

	* denitrification.C (tick): Use it.
	(f_Theta): Removed.
	(water_factor_fast, alpha_fast): New parameters.
	(converted_fast, potential, potential_fast): New log variables.
	* summary_simple.C (print_sum): New parameter.
	* lib/log.dai ("Carbon Balance"): Removed CO2_fast.
	* lib/log.dai ("Denitrification"): New log parameterization.

	* organic_matter.C, organic_matter.h (CO2_fast): New member function.

	* Version 2.86 released.

2003-05-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Total Water Balance"): New summary.
	("Root Zone Water Balance"): Us it.
	("NH4 Soil Balance", "NO3 Soil Balance"): New summaries.
	("N Balance"): Use them.
	("Carbon Balance"): Added summary.

2003-05-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* symbol.C (int2id): Negative integers are not fast.
	* log.h (output): Removed possibility of outputing strings.
	* all: Updated.

	* geometry.C (add_layer): Removed superflous check.

	* select.h: Use symbol instead of string for destination tags.
	* log_extern.C, log_table.C: Update implementors.
	* log_table.h: Use symbol instead of string for source tags.
	* cdaisy.C: Update caller.

	* log.h, log.C, log_table.C (summarize, initialize): New virtual
	member functions. 
	* daisy.C (run): Call it.
	* symbol.h, symbol.C (symbol): Allow default initializer.
	* destination.C, destination.h: New utility.
	* Makefile (OTHER): Added it.
	* summary.C, summary.h: New component.
	* Makefile (COMPONENTS): Added it.
	(SUBMODELS): Moved nitrification.C to COMPONENTS.
	* summary_simple.C: New model.
	* Makefile (MODELS): Added it.
	* log_table.C: Use it.

2003-05-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.85 released.

2003-05-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_all.C (insert_active): Use iterators.
	(match): Ditto.
	(done): Ditto.
	(initial_match): Ditto.
	(initial_done): Ditto.

	* Version 2.84 released.

2003-05-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_table.C (time_columns): New parameter.
	* log.h (done): Take time argument.
	* all: Update callers and implementors.
	* lib/log.dai: Use it.

	* uzlr.C (description): Fix sign. Reported by <mmo@kvl.dk>.
	(tick): Handle pressure top.

	* Version 2.83 released.

2003-05-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log.h (check_member): Split into check_leaf and check_interior.
	* all: Updated callers and implementors.

	* soil_water.C (initialize): Added log file message if automatic
	macropores are added. 

	* Version 2.82 released.

	* select.h, select.C, log_all.C: Minor speedups.

2003-05-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.81 released.

2003-05-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* plf.C (slope): New member.
	(operator ()): Speeded up.

	* log_select.C (check_member,open,close,output): Moved to
	'log_all.C'.

2003-05-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.80 released.

2003-05-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.79 released.

2003-05-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log.C, log.h (initial_match, initial_done): New virtual members.
	* log_all.C, log_all.h (initial_match, initial_done): Implemented.
	* log_select.C, log_select.h (initial_match, initial_done): Ditto.
	* daisy.C (initial_logs): New member function.
	(logging): New member variable.
	(tick_logs, tick): Use it.
	* cdaisy.C (daisy_daisy_tick_time): Call it.
	* weather_std.C (initialize): Read previous hour.
	* select.h, select.C (interesting_content): New parameter.
	* lib/log.dai: Specify it.

	* cdaisy.C (daisy_daisy_tick_action): Call 'Action::tick'.

	* parser_file.C (load_list): Add warning for parameters specified
	twice. 
	* parser_file.C (add_derived): Ditto for duplicate parameterizations.

	* organic_matter.C (root): Changed default value to 800
	[kg/ha/y].  It used to be 1.20 Mg * 0.4, but that number did not
	include rhizodeposition.

	* Version 2.78 released.

2003-05-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic_hypres.C (topsoil): New parameter.

	* select_date.C: Resurrected.
	* Makefile (MODELS): Added it.
	* log.h (output): Restored virtual function.
	* log_alist.C, log_select.C, log_select.h (output): Implement it.
	* select.C, select.h (output_time): Restored virtual function.

2003-05-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C (K_aquitard): Changed default value from 1e-5
	to 1e-4 [cm/h].
	* txt/tutorial.tex (subsection{Groundwater and Drainage}): Updated.

	* Version 2.77 released.

2003-05-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/dk-horizon.dai: New file.
	* lib/Makefile (DAISY): Added it.

2003-05-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log_all.C: New utility.
	* Makefile (SPECIALS): Added 'log_all.C'.
	* daisy.C, daisy.h: Use it.
	* log_select.C: Cleanups.
	* select.h, select.C (flux): New parameter.
	(match): Use it.
	* log_select.C: Update caller.
	* lib/log.dai: Updated.

	* Makefile (OTHER, SUBMODEL): Moved 'time.C' to SUBMODEL.
	
2003-05-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select.h, log_select.C: Cleanups and more speedups.

	* Version 2.76 released.

2003-05-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select.C, select_number.C, select_average.C, select_min.C, 
	select_max.C (output_number): Removed call to 'is_active'.
	* select.C, select_array.C, select_content.C, select_flux_botton.C,
	select_flux_top.C, select_index.C, select_interval.C
	(output_array): Ditto.

	* select.h (valid_level): New public data member.
	* select.C (open_group, open, close): Update it.
	* log_select.C (output): Use it.

2003-05-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_harvest.C (name, crop): Renamed 'name' to 'crop'.

2003-05-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* symbol.h, symbol.C: New utility.
	* Makefile (OTHER): Added it.

	* log_table1.C: No longer in use.
	(MODELS): Removed.
	(REMOVE): Added log_table1.C.

	* Version 2.75 released.

2003-04-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (update_pools): Fix initialization order.

	* txt/introduction.tex (subsection{Log File Generation}): Updated
	example. 

2003-04-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C (GroundwaterPipeSyntax): Explain about
	aquitart horizon.
	* soil.C (load_syntax): Ditto.

2003-04-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.74 released.

2003-04-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_water.C (initialize): Give error if h and Theta does not
	match, and use h.

	* horizon_std.C: Fixed comment.

	* horizon.C (load_syntax): Removed 'Theta_res' and 'Theta_sat'
	from hypres alist.

	* groundwater.h, grgroundwater.C, groundwater_pipe.C
	(Z_aquitard, K_aquitard, set_Z_aquitard): New virtual members.
	* soil.C, soil.h (initialize): Made groundwater non-const.
	* soil.C (initialize): New automatic aquitard horizon.
	
2003-04-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.73 released.

2003-04-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Organic Matter"): Added SOM3.

2003-04-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* time.C, time.h: Made it a submodel.
	* daisy.C (time): Use it.
	* condition_time.C (time): Ditto.
	* action_wait.C (end_time): Ditto.
	* harvest.C (time): Ditto.
	* harvesting.C (last_cut): Ditto.
	* am.C (creation): Ditto.
	* action_fertilize.C (doIt): Update caller.
	* syntax.C, syntax.h (Syntax::Date): Removed.
	* alist.h, alist.C: Removed support for Time values.
	* document_LaTeX.C: Ditto.
	* parser_file.C: Ditto.
	* printer_file.C: Ditto.
	* qmain_edit.C: Ditto.
	* qmain_populate.C (enter_parameter): Ditto.
	* select.C, select.h (output_time): Removed.
	* select.C (load_syntax): Remeved reference to date types.
	* log.h, log_select.C, log_select.h, log_alist.h, log_alist.C
	* olog_table1.C (output): Cannot log time values. 
	* Makefile (MODELS): Removed 'select_date.C'.
	* lib/log.dai: Updated callers.
	* cdaisy.C, cdaisy.h (daisy_alist_get_time): Removed.
	(daisy_alist_set_time): Ditto.
	* txt/guide.tex (subsection{Date}): Removed.
	* txt/introduction.tex: Removed references to at date type.
	* parser_file.C (load_list): Don't force parentheses in alist in order.
	* select_number.C (output_integer): New member function.

	* parser_file.C (nest): Specify filename in treelog.
	* options.C (Options): Don't specify filename here.

	* txt/guide.tex (subsection{Files}): Fixed typo.

2003-04-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.72 released.

2003-04-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* horizon.C, horizon.h (C_per_N): New parameter and member function.
	* soil.C, soil.h (C_per_N): New member function.
	* organic_matter.C (update_pools): Take new 'total_C_per_N'
	argument.
	(initialize): Update caller.

	* Version 2.71 released.

2003-04-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Carbon Balance"): Added fast CO2.

2003-04-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (CO2_fast): New log variable.
	(CO2_threshold): New parameter.

2003-04-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.70 released.

2003-04-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* horizon.C, horizon.h (turnover_factor): New parameter.
	* soil.C, soil.h (turnover_factor): New member function.
	* organic_matter.C: Use it.

	* horizon.C (rho_mineral, rho_humus, rho_water, rho_ice)
	(c_fraction_in_humus): Added.
	* horizon.h (rho_mineral, rho_humus, rho_water, rho_ice)
	(c_fraction_in_humus): Removed.
	* soil_heat.C (rho_water, rho_ice): Added constants.
	* soil_water.C: Ditto.
	* adsorption_freundlich.C (c_fraction_in_humus): Added.
	* adsorption_linear.C: Ditto.
	* soil.C, soil.h: Moved all member function definition to source
	file. 

	* Version 2.69 released.

2003-04-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* mathlib.h (safe_pow): Added integer version.

2003-04-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.68 released.

2003-04-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (SOM_limit_where, SOM_limit_lower)
	(SOM_limit_upper): New parameters to the `init' submodel.
	(partition, initialize) Use them.

	* organic_matter.C (partition): Try to partition as topsoil if
	subsoil partitioning does not work.  This may happen if input is
	too high, so SOM3 becomes negative.
	
	* options.C (Options): Fix quote.
	* treelog_dual.C (init_one): Ditto.

	* hydraulic_hypres.C (initialize): Doc fix.

	* hydraulic.C (check_K_sat): Doc fix.

2003-04-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (AM_Syntax): Changed "weight" dimension from "T w.w./ha"
	to "Mg w.w./ha".
	* units.C (standard_conversions): Added "T w.w./ha" as an alias
	for "Mg w.w./ha".

	* Version 2.67 released.

2003-04-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic.C (K_at_h): New paramemter.
	(initialize): Use it.
	(check_K_sat): New function.
	(load_K_sat): Use it.

2003-04-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic.h, hydraulic.C (zero_Theta_res): Removed.
	(K_sat): Moved here from subclasses.
	* hydraulic.C (Hydraulic): Made 'Theta_res' and 'Theta_sat'
	optional. 
	(load_syntax): Renamed to 'load_Theta_res'.
	(load_Theta_sat): New function.
	(load_K_sat): New function.
	* hydraulic_*.C: Updated.	

	* hydraulic_hypres.C (initialize): Use parentheses in debug
	messages. 
	* hydraulic_Cosby.C (initialize): Ditto.
	* hydraulic.C (load_syntax): Renamed 'K_sat_range' to
	'Theta_sat_range'. 

	* root_system.C (tick_day): Renamed from 'tick'.
	(tick_hour): New function.
	* phephenology.h, phephenology.C (soil_h): Removed parameter.
	(soil_temperature, partial_soil_temperature): Moved to root system.
	* root_system.h, root_system.C: Moved from phenology.
	(tick_day): Renamed from 'tick'.
	(tick_hour): New function.
	* phephenology.h, phephenology.C, phenology_std.C,
	phenology_TSum.C (emergence): Take h and T parameters.
	* crop_std.C, crop_simple.C (tick): Update caller.

	* canopy_simple.C (EpFac): Changed default to 1.15.

	* Version 2.66 released.

2003-04-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* condition_time.C (match): Only match on Sundays.

	* Version 2.65 released.

2003-04-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/pea.dai ("Pea"): Ditto.

	* lib/grass.dai ("Grass to grain"): Removed 'EpFac'.

	* organic_matter.C (Initialization::variable_pool_2): New member.
	(Initialization::net_mineralization): New member.
	(partition): Use them.
	(initialize): Update caller.

	* organic_matter.C (partition): Added a few 'const's.

2003-04-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.64 released.

2003-04-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (partition): Count initial aom content as part
	of the humus.

	* organic_matter.C (load_syntax): Added default SOM3 pool.
	(Initialization::end): Made it a real member.
	(partition): New 'top_soil' parameter.
	(initialize): Update caller.
	* soil.C (check): Allow 'SOM_fractions' to be smaller than
	'som.size ()'.
	* horizon.C, horizon.h (initialize): Ditto.
	* column_base.C, column_base.h (initialize_common): Renamed from
	'initialize'.
	* column_inorganic.C, column_std.C (initialize): Update caller.

	* organic_matter.C (partition): Made it const.
	(update_pools): New member function.
	(initialize): Update caller.

	* organic_matter.C (Initialization::variable_pool): New member.
	(partition): Use it.
	(initialize): Update caller.

	* Version 2.63 released.

2003-04-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* root_system.C, root_system.h (tick): Take T parameter instead of
	'soil_heat'. 
	* crop_std.C (tick): Update caller.
	* crop_simple.C (tick): Ditto.

	* root_system.C, root_syste.h (DptEmr): Removed parameter.
	* crop_std.C (tick): Use 'Depth' instead of 'DptEmr'.

	* root_system.C, root_system.h (PenClayFac): New parameter.
	* root_system.C (tick): use it.

	* Makefile (REMOVE): Added development.C and development.h.
	(SUBMODELS): Removed them.

2003-04-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C (turnover): Added assertion.

2003-04-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* mathlib.h (safe_pow, safe_sqrt, safe_log, safe_acos, safe_asin):
	New functions.
	(pow, sqrt, log, acos, asin): Use them.

2003-03-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.62 released.

2003-03-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* fao.C, fao.h: New utility.
	* Makefile (OTHER): Added it.
	* pet_PM.C, pet_PM.h: Move FAO utilites.
	* bioclimate.C, bioclimate.h: Ditto.
	* weather.C, weather.h: Ditto.
	(elevation): New function.
	* pet_makkink.C: Update caller.
	* weather_old.C: Ditto.
	* weather_std.C: Ditto.

	* weather.C (tick_after): Use hourly extraterrestrial radiation
	for hourly claudiness. 

2003-03-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* gaussj.C (solve): Check for non-finite numbers.

	* svat_pmsw.C (tick): Give error if crop height > 2.5 m.
	(gaussj): Commented out.
	(tick): Use GaussJordan instead of gaussj.
	Added many checks.
	
2003-03-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* svat_pmsw.C (gaussj): Throw instead of exit on error.
	(tick): Catch errors here.

2003-03-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.61 released.

2003-03-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* syntax.h (check_list_fun): Removed.
	* syntax.C, syntax.h (add_checks): Removed.
	* syntax.C (list_checker): Removed.
	(check): Updated caller.

	* rootdens_PLF.C (Check_Indexes): New member class.
	(check_alists): Removed.
	(updated): Use it.
	(Rootdens_DS_Depth_Syntax): Update.

	* vcheck.h, vcheck.C (MinSize): New member class.
	(min_size_1): New static member function.
	
	* geometry.C (CheckLayers): New class.
	(initialize_layer): use it.
	(check_layers): Removed.
	(load_syntax): Use VCheck.
	(check_alist): Emptied.

	* Version 2.60 released.

2003-03-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C (turnover_pool): Don't process tiny pools.
	(turnover): Ignore very slow rates.
	* aom.C (tick): Ignore small som fraction.

	* geometry.C (add): Added checks.
	(extract): Made it more numerically stable.

	* assertion.C, assertion.h (non_negative): Nw member function.
	* assertion.h (assert_non_negative): New macro.
	* om.C: Added checks.
	* organic_matter.C: Ditto.

	* Version 2.59 released.

2003-03-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* syntax.C (add_checks): Renamed from 'add_check'.

	* geometry.C (add_layer): Update caller.
	* rootdens_PLF.C (load_syntax): Ditto.

	* assertion.C, assertion.h (error, warning, debug): New functions.
	* assertion.C (failure, bug, warning): Use them.

	* assertion.C (failure, panic): Removed unnecessary parentheses.
	
	* organic_matter.C (input_from_am): The som buffer does not have
	an efficiency.

	* log_harvest.C (check): Check for write error.
	* log_table1.C (check): Ditto.
	* log_table.C (check): Ditto.
	* log_checkpoint.C (done): Warn for write error.

	* lib/log.dai ("Carbon Balance"): Accumulate C_Loss.

	* Version 2.58 released.

2003-03-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (Initialization): Mix input from roots in
	plowing layer. 

2003-03-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* aom.C, om.C, smb.C: Added check.

	* Version 2.57 released.

2003-03-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* canopy_std.C (CanopyStructure): Added some consts.

	* action_sow.C (diIt): Added space to message.

2003-03-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* txt/dwf.tex (chapter{Daisy Weather File Format}): Warn about
	specifying End a few days before the end of the file.
	* lib/weather.dwf (End): Ditto

2003-02-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.56 released.

2003-02-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* tmpstream.h: Added GCC 2.95 support.
	* vcheck.C: Ditto.

	* printer_file.C, printer_file.h (print_string): Exported.
	* document_LaTeX.C (print_string): New function.
	* document_LaTeX.C (print_sample_ordered, print_sample_entry)
	(print_sample_header): Use it.

	* document_LaTeX.C (print_entry_value, print_entry_category)
	(print_entry_type, print_entry_submodel): Remove redundant arguments. 
	(print_submodel_entry): Update caller.
	(print_sample_entry): Print simple default value.
	* document.C (print_sample): Update caller.
	* txt/introduction.tex (subsection{Sample}): Describe it.

2003-02-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C, am.h (check_om_pools): New function.
	* am.C (AM_Syntax): Use it.
	* bioincorporation.C (load_syntax): Use it.

	* bioincorporation.C (load_syntax): Added checks.

	* Version 2.55 released.

2003-02-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/fertilizer.dai (horse_manure): Change 'NH4_evaporation' to
	'volatilization'. 

	* am.C (get_NH4, get_volatilization, check_organic, AM_Syntax):
	Removed the obsolete NH4_evaporation parameter.

	* harvesting.C (load_syntax): Clarify doc string.

	* document.C (print_submodel, print_document, print_sample):
	Removed MS-for hack. 
	* printer_file.C (print_alist): Ditto.
	* plf.C (operator +): Ditto.
	* document.C (print_submodel, print_document): Ditto.
	* depend.C (resequence): Ditto.

	* om.h, om.C, aom.h, aom.C (initial_fraction): Moved parameter
	from OM to AOM. 

	* clayom_biomod.C (set_rates): Added checks.

	* soil_water.h: Undid last change.

2003-02-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.54 released.

2003-02-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_water.h: Use namespace std to see if that help performance
	on MinGW.

	* organic_matter.C (partition): More debug code.

	* Version 2.53 released.

2003-02-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (partition): Fix throw of tmp object.

2003-02-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (partition): BCC warning.

	* crpn.C, crpn.h (NO3_root_min, NH4_root_min): New parameters.
	* root_system.C (solute_uptake): New 'C_root_min' argument.
	(nitrogen_uptake): Update caller.
	(nitrogen_uptake): New 'NO3_root_min' and 'NH4_root_min'
	parameters. 
	* crop_simple.C (tick): Update caller.
	* crpn.C (update): Update caller.

2003-02-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.52 released.

2003-02-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.51 released.

2003-02-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (partition): SOM pools are not affected by
	efficiency.

2003-02-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.50 released.

2003-02-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vcheck.C, vcheck.h (SumEqual): Made it a member of VCheck.
	(StartValue, EndValue, FixedPoint, All): New checks.
	* macro_std.C (load_syntax): Use them.
	(check_alist): Removed duplicate check.
	(check_alist): Added check that end pressure is lower than initial
	pressure.

	* macro_std.C (pressure_initiate, pressure_end): Added default
	values. 
	* macro_std.C, macro.h (create): New function.
	* soil_water.C (initialize): Use it.
	* macro.C, macro.h, macro_none.C (none): New predicate.
	* soil_water.C (initialize): Use it.
	* groundwater.C, groundwater.h, groundwater_pipe.C (is_pipe,
	pipe_height): New functions.
	* geometry.C (initialize_zplus): Use them.
	* soil_water.C (initialize): Use them.

	* geometry.C, geometry.h (initialize_zplus): New 'max_interval'
	parameter. 
	* soil.C (initialize): Update caller.

	* assertion.C (message): Use cerr if no logs are defined.
	(failure, panic): Throw an int instead of calling exit.
	* main.C (main): Catch ints.

2003-02-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_water.C, soil_water.g (Implementation, impl): Moved
	everything to impl.
	(macro): Made it optional.

2003-02-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.49 released.

2003-02-20  Per Abrahamsen  <abraham@dina.kvl.dk>


	* parser_file.C (load_list): Hande integer sequences.
	* organic_matter.C (Initialization, partition, initialize): More
	debug support.

2003-02-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* syntax.C (check): Made "key" const.
	* om.C (load_syntax): Make sure "initial_fraction" is a fraction.
	(check_alist): Removed dead code.
	* am.C (initialize): Don't assume "initial_fraction" is specified.
	(AM_Syntax): Ditto.

2003-02-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.48 released.

2003-02-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* all: BCC 5.0.1 fixes.

2003-02-17  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (AM_Syntax): Use Mg instead of T (or t).
	* vegetation_permanent.C (VegetationPermanentSyntax) Ditto.
	* crop_simple.C (CropSimpleSyntax): Ditto.
	* lib/log.dai: Use Mg instead of Ton.

2003-02-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil.C (end_of_first_horizon): New function.
	* gaussj.C, gaussj.h: New utility.
	* Makefile (OTHER): Add it.
	* horizon.C, horizon.h, soil.h (SOM_C, SOM_C_per_N): Removed.
	(humus_C, SOM_C_per_N, SOM_fractions): New functions.
	* mathlib.C (rate_to_halftime): New function.
	* organic_matter.C (input_from_am, partition): New functions.
	(Initialization) New submodel.
	(initialize): Use them
	(check_alist): More checks.
	* weather.C, weather.h (average_temperature): New function.
	* organic_matter.C (initialize): Take new T_avg argument.
	* column_std.C (initialize): Update caller.

	* column_std.C, column_base.C (initialize): Move Treelog header to
	ColumnStandard. 
	* column_inorganic.C (initialize): New function.

2003-02-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* common.h: Cleanup.

	* Version 2.47 released.

2003-02-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C (load_list): Be more strict with parentheses.
	* txt/introduction.tex (subsection{Management}): Fixed example.

	* weather_std.C (check): Fixed spelling error. 

	* hydraulic_hypres.C, hydraulic_Cosby.C (set_porosity, output):
	Prevent Theta_sat from being modified.

2003-02-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* common.h: Cleanup.

2003-02-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* library.h, chemicals.h (Implementation): Made it public (for icc).
	* column_std.C (fertilize): Count NH4 lost to volatilization in
	fertilized_NH4. 
	* weather_std.C (data_description): Changed manifest constants
	from integers to doubles (to shut up icc).
	* units.C (ConvertIdentity): Added default constructor (to silence
	icc). 
	* production.h, production.C (GrowthRespCoef): Removed extra const
	(found by icc)
	* am.C (unlock): Removed extra ";" (found by icc).
	* soil.C (Soil): Ditto.
	* geometry.C (initialize_zplus): Ditto.
	* assertion.C (message, failure, bug, warning, panic): Ditto.
	* path.C (Path): Ditto.
	* syntax.C (add_submodule, add_submodule_sequence): Ditto.
	* component-headers: Declare content (for icc).
	* am.h (class AM): Made friends with Implementation (for icc).
	* plf.h (class PLF): Ditto.
	* dom.h (class DOM): Made friend with Element (for icc).
	* librarian.h (class Librarian): Allow nested class access to
	private types (for icc).

2003-02-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_std.C (read_line): Extra check for file end.

2003-02-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.46 released.

2003-02-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile: Create and distribute mingw32 version.

	* assertion.C (message): New function.
	(warning): New function.
	* assertion.h (daisy_warning): Use it.

	* hydraulic.C (K_to_M): Survive very steep conductivity curves.

	* hydraulic_yolo.C, hydraulic_M_vG_compact.C, hydraulic_M_vG.C,
	hydraulic_B_vG.C (M_): New member variable.

	* parser_file.C (load_list): Don't build or add invalid PLF.

	* weather_std.C: Added assertion about use uninitialized.
	(tick): Make sure to initialize.

	* time.C (tick_day): Remove BCC warning.

	* Version 2.45 released.

2003-02-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lexer.C, lexer.h (seek): New function.
	* parser_file.C (load_list): Handle alists and plfs in order.
	* time.C, time.h (between): New function.
	(tick_year): New function.
	* vcheck.h, vcheck.C (VCheck): New utility.
	* Makefile (OTHER): Add it.
	* syntax.C, syntax.h (add_check, check): Support it.
	* parser_file.C (load_list): Support it.
	* weather_std.C (missing_years): New parameter.
	(read_new_day): Use it.

	* Version 2.44 released.

2003-02-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Forced LAI"): New log model.

	* canopy_std.C, canopy_std.h (tick): New force_CAI argument.
	* crop_std.C (tick): Obey forced CAI.
	* crop.h, crop_simple.C, crop_old.C, crop_sold.C (tick): Warn
	about forced CAI.
	* crop.C, crop.h, crop_std.C (SimLAI): New virtual member function.
	* canopy_std.C, canopy_std.h (ForcedCAI, SimCAI): New log
	variables. 
	* canopy_std.C, canopy_std.h (tick): 

	* vegetation_crops.C, vegetation_permanent.C, vegetation.h (tick):
	Merged organic and inorganic versions.
	* column_inorganic.C, column_std.C (tick): Update callers.

	* plf.C (empty): New utility.
	* canopy_simple.C (load_syntax): Use it.
	* organic_matter.C (load_syntax): Ditto.
	* nitrification_solute.C (NitrificationSoluteSyntax): Ditto.
	* nitrification_soil.C (NitrificationSoilSyntax): Ditto.
	* denitrification.C (load_syntax): Ditto.
	* column_std.C (ColumnStandardSyntax): Ditto.
	* chemical_std.C (ChemicalStandardSyntax): Ditto.

	* plf.C (operator +): Fixed spelling error in comment.

	* vegetation_permanent.C (tick): Add newly created litter.

	* crop_simple.C (tick): Updated messages.

2003-01-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* production.C (tick): Make it more robust.

	* syntax.C (type_name): Removed static assertion.

	* lib/wwheat.dai ("Winter Wheat"): Fixed Partit so shoot < 1.0.
	("Winter Wheat; Eest"): Ditto.
	* lib/pea.dai ("Pea"): Fix Patit Stem so shoot < 1.0.
	* lib/maize.dai ("Ikuwala Maize"): Ditto.

	* partition.C (operator()): Added checks.

2003-01-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* partition.C (operator()): Add check.

	* syntax.C, syntax.h (add): Add range check for PLF.
	* parser_file.C (load_list): Add range check for PLF.
	* photosynthesis.C (load_syntax): Added checks.
	* crpn.C (load_syntax): Ditto.
	* denitrification.C (load_syntax): Ditto.
	* organic_matter.C (load_syntax): Ditto.
	* ridge.C (load_syntax): Ditto.

	* plf.C, plf.h (min, max): New functions.
	* partition.C (load_syntax): Better descriptions.
	(check_alist): New function.
	(load_syntax): Use it.

2003-01-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C (Z_aquitard): Improved description.

	* Version 2.43 released.

2003-01-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/grass.dai (Grass): Allow grass to be harvest after it is
	ripe. 

	* phenology.h, phenology_TSum.C, phenology_std.C (tick_daily):
	Don't use name. 
	* crop_std.C (tick): Update caller.

	* crop_std.C (tick): Modify messages.

	* harvesting.C (load_syntax): Allow DS_max > 2.0.
	(operator ()): Don't require stem, root reserves may be sufficient.

2003-01-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_std.C (check): Don't try to run simulation if we could
	not open the file.

2003-01-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* phenology_std.C (EmrTSum): Removed default value (of 100).

	* phenology_TSum.C: New model.
	* Makefile (MODELS): Added it.

	* hydraulic_hypres.C (initialize): Removed debug messages.

	* Version 2.42 released.

2003-01-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic_hypres.C (initialize): Fixed K_sat dimension.
	(check_alist): Allow specifiction of Theta_res.
	(Theta_res): Default value 1%.

2003-01-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* units.C (crop_time): Remove duplicate assignment.

	* bioclimate_std.C (irrigation_subsoil, irrigation_total): New log
	variables. 
	* bioclimate_std.C, bioclimate.h (set_subsoil_irrigation): New
	function. 
	* column_base.C (set_subsoil_irrigation): Call it.
	* lib/log.dai ("Root Zone Water Balance"): Log it.

	* Version 2.41 released.

2003-01-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* harvesting.C (operator): If we remove both leaf and stem, kill
	of the plant.

	* parser_file.C (load_derived): Take original alist as an
	argument, and use it when "original" is specified as a
	superclass. 
	(load_list): Update caller.
	* lib/grass.dai (Grass): Use it.
	* lib/wwheat.dai ("Winter Wheat; Eest", "Winter Wheat; Foulum"): Ditto.
	* lib/sbarley.dai ("Spring Barley; Foulum"): Ditto.
	* lib/maize.dai ("Ikuwala Maize", "Silage Maize"): Ditto.
	* txt/introduction.tex (Library Components):
	Documented it.

	* txt/introduction.tex (Submodels and Fixed Components): Document
	how the original value is modified rather than overwritten.

2003-01-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* assertion.C, assertion.h (panic): New member function.
	* assertion.h (daisy_panic): New macro.

	* parser_file.C (skip_to_end): Better error handling.

	* crop_std.C: Use phenology component instead of development
	submodel.  
	* photosynthesis.h, photosynthesis.C: Ditto.
	* lib/log.dai ("Crop Production"): Updated.
	* lib/*.dai: Fixed default crop parameterizations.

	* weather.C (precipitation): New log variable.
	* lib/log.dai ("Weather"): Use it.

2003-01-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* phenology.h, phenology.C: New component.
	* Makefile (COMPONENTS): Add it.
	* phenology_std.C: New model.
	* Makefile (MODELS): Add it.

2003-01-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.40 released.

2003-01-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic.h, hydraulic.C (initialize): New Treelog argument.
	* hydraulic_hypres.C (initialize): Use it.
	* hydraulic_Cosby.C (initialize): Ditto.
	* horizon.C, horizon.h (initialize): Ditto.
	* soil.C (initialize): Ditto..

	* horizon.C: Allow user to specify "sand" instead of "fine_sand"
	and "coarse_sand".
	
2003-01-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* harvesting.C (operator): Don't require leaf to survive, as stem
	may provide photosyntheses. 

	* action_harvest.C (doIt): Better message.

2002-12-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* horizon.C (check_alist): Check that dry_bulk_density is
	specified for hypres.

	* horizon.C, horizon.h (initialize): New function.
	* soil.C (initialize): Call it.

	* Makefile (MODELS): Added hypres.

2002-12-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic.C, hydraulic.h, hydraulic_Cosby.C (initialize): Take
	more parameters. 

	* hydraulic_hypres.C: New model.
	

	* hydraulic_Cosby.C (Hydraulic_CosbySyntax): Check that the user
	does not set `Theta_sat'.

2002-12-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.39 released.

2002-12-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* txt/tutorial.tex (subsection{Horizons}): New description 

	* soil.C (load_syntax): Changed default dispersivity from 6 to 5. 

2002-12-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* surface.C: Don't include `am.h'.
	* daisy.C: Ditto.

	* lib/fertilizer.dai (slurry): Use Sander parameters.
	* bioincorporation.C (load_syntax): Ditto
	* am.C (default_AM): Ditto.
        * Updated crop parameterizations as well.
	
2002-12-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (load_syntax): New parameters from Sander Bruun.

2002-12-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (load_syntax): Added more documentation to
	`water_factor'. 

2002-11-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* weather_std.C (initialize): Changed errors for unreasonable
	precipitation corrections to warnings.

2002-10-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* macro_std.C (tick): Fix check.

	* Merged SHA changes.
	
2002-10-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* macro_std.C (tick): More debug information.

2002-10-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* log.C: Include tmpstream.h in order to get ostream.

2002-10-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* assertion.h: Don't use __FUNCTION__ on any Borland version.

	* Merged SHA changes.

2002-10-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.38 released.

2002-09-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation_crops.C (DM_by_name): Support crop name "all".
	* condition_crop.C (ConditionCropSyntax): Document it.

2002-08-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C (turnover): Make it more robust by leaving 1 [ug/l].

	* action_repeat.C (ActionRepeatSyntax): Fix gramtical error.

	* organic_matter.C (clayom): Removed const for BCC5.0.

2002-08-13  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.37 released.

	* aom.C, column_std.C, om.C, om.h, smb.C, smb.h: More clayom
	modifications. 
	
2002-08-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* clayom_biomod.C: New model.
	* Makefile (MODELS): Add it.

2002-08-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* clayom_old.C: New model.
	* Makefile (MODELS): Add it.
	* clayom.C, clayom.h: New component.
	* Makefile (COMPONENTS): Add it.
	* organic_matter.C, organic_matter.h: Use it.

2002-08-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.36 released.

2002-07-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C (add_derived): Better error message.

	* lib/log.dai ("DOM-N", "DOM-C"): New log models.

2002-07-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (AM_Syntax): Handle single OM pool.

2002-07-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* units.C (standard_conversions): Added "MJ/d/m^2".
	(standard_conversions): Added "m/s".

	* Version 2.35 released.

2002-07-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* canopy_std.C (cut): Take WStem parameter.
	* crop_std.C (harvest): Update caller.

	* hydraulic_B_C.C, hydraulic_M_C.C (b): Fixed range.

2002-06-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/pea.dai, lib/srape.dai (LeafAIMod): Comment out.

	* dom.C, dom.h (C_source, N_source): New functions.
	(C_drain, N_drain): Removed.
	* organic_matter.C (tick): Use them
	* organic_matter.C (tick): Removed DOM transport.
	* organic_matter.C, organic_matter.h (transport): New function.
	* column_std.C (tick): Call it.

2002-06-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* assertion.C, assertion.h (bug): New member function.
	* assertion.h (daisy_bug): New macro.
	* groundwater_pipe.C: Use them.
	* groundwater.C, groundwater.h (update_water): Don't take Treelog
	argument. 
	* soil_water.C (tick): Update caller.

2002-06-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* dom.C: More work.
	* organic_matter.C (tick): Fix caller.

	* units.C: Allow conversions to ignore identical timestep.
	* select.C (initialize): Try conversion with 'h' as timestep.

	* lib/log.dai ("DOM Pools"): New log model.

2002-06-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Organic Matter"): Removed DOM.

2002-06-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* dom.C (tock): New function.
	(turnover): Call it.  Take new soil and soil water arguments.
	* organic_matter.C (tick): Update caller.

2002-06-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.34 released.

2002-06-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* dom.h, dom.C: Rewrote.
	* aom.C, organic_matter.C, om.C:  Update callers.
	* organic_matter.C, organic_matter.h (mix, swap): Take SoilWater
	argument. 
	* column_std.C (mix, swap): Update caller.
	* organic_matter.C, organic_matter.h (initialize): Take SoilWater
	argument. 
	* column_std.C (initialize): Update caller.

2002-06-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* transport.h, transport_cd.C, transport_none.C,
	transport_convection.C (tick): Avoid Solute argument.
	* solute.C (tick): Update caller.

	* Version 2.33 released.

2002-06-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C, am.h (default_AM): Renamed from default_AOM.
	* som.C, som.h, smb.C, smb.h, aom.C, aom.h, dom.C, dom.h: New
	submodels.
	* Makefile (SUBMODELS): Add it.
	(SPECIALS): Moved om.C here.
	* om.C, om.h (tick): Update callers.
	* am.C, organic_matter.C: Update users.
	* vegetation_permanent.C, bioincorporation.C: Update callers.
	* crop_old.C, crop_sold.C, crop_simple.C: Ditto.
	* harvesting.C: Ditto.

2002-06-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Organic Matter"): Added DOM.

	* om.C (goal_C_per_N): New variable.
	* organic_matter.C (initialize): Initialize it.
	* om.C (find_abiotic): New overloaded function.
	(tick): Call it.  Take dom arguments.
	* organic_matter.C (tick): dom turnover.
	(check_alist): Require dom C/N to be specified.
	
2002-05-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (dom): New member. 
	(total_N, total_C, output, mix, swap, initialize, load_syntax): Use it.

	* Version 2.32 released.

2002-05-31  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C, om.h (goal_C_per_N): New public member function.
	(tock): Use it.
	* organic_matter.C (tick): Use it.

2002-05-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C, om.h (add): Removed unused function.
	* am.C (add): Remove unused caller.

	* organic_matter.C (tick): Update caller.
	(om_compare): Ditto.
	(initialize): Ditto.

	* om.h, om.C (N, C_per_N): Use N instead of C_per_N.
	Update callers.
	* am.C (initialize): Ditto.

	* options.h, options.C (timestamp): Removed.
	* main.C (main): Update caller.

	* all: Fixed lots of BCC warnings.

	* mathlib.h (finite): Moved here from `common.h'.

	* Version 2.31 released.

2002-05-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* nrutil.C, nrutil.h (nrerror): Promise not to touch the string.

	* mathlib.h (double2int, int2double, int2char): New functions.
	* all: Use them instead of casts.

	* crop.h, crop.C, crop_simple.C, crop_old.C, crop_sold.C,
	crop_std.C (initialize_organic, initialize_inorganic):  Renamed
	from overloaded `initialize'.
	* vegetation_crops.C (sow): Update caller.
	(initialize): Ditto.

	* log.h, log_select.h, log_select.C, log_clone.h, log_clone.C,
	log_table1.C, log_alist.h, log_harvest.C (check_member): Renamed
	from `check'.  
	* column_std.C (output_inner): Update caller.
	* action_lisp.C, bioincorporation.C, crop_old.C, crop_sold.C,
	om.C, organic_matter.C, soil_chemicals.C, soil_chemicals.C,
	soil_heat.C (output): Update callers. 
	* log.C (check_entry): Update caller.
	* log_select.C (check_derived): Ditto.

	* horizon.C (initialize): Remove old style casts.
	* parser_file.C (get_number): Ditto.
	* soil_heat.C (output): Ditto.
	* lexer_data.C (get_number): Ditto.
	* geometry.C (initialize_zplus): Ditto.
	* select_average.C (done): Ditto.
	* crop_simple.C (check_alist): Ditto.
	* parser_file.C (load_list): Ditto.

2002-05-29  Per Abrahamsen  <abraham@dina.kvl.dk>

	* path.h, path.C (Input, Output): New classes.
	* printer_file.C (PrinterFile): Can now be constructed from an
	ostream reference.
	(print_plf): Attempt to wrap at 72 columns.
	* printer_file.C, printer_file.h, printer.h (print_alist): Add
	`super' agrument.
	* qmain.C (save_file): Update caller.
	* log_checkpoint.C (done): Ditto.
	* cdaisy.C, cdaisy.h (daisy_printer_alist): Ditto.
	* document_LaTeX.C (is_submodel, find_submodel): New utility
	functions. 
	(print_entry_type): Use them.
	(print_entry_type): Drop `size' argument.
	(print_entry_value): Also print complex default values. 
	(print_users): Get rid of "@" in references.

2002-05-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* transport_convection.C (tick): Allow for more noise in mass
	balance check..
	Initialize of J after time step reduction.

2002-05-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_base.C (initialize): Add treelog nesting.

	* treelog.C, treelog.h, treelog_dual.C, treelog_dual.h (debug):
	New virtual member function.
	* geometry.C (initialize_zplus): Use it.

	* Version 2.30 released.

2002-05-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* treelog.h, treelog_dual.h, treelog_dual.C, treelog_stream.h,
	treelog_stream.C (flush):  New virtual member function.
	* assertion.C (failure): Use it.

	* assertion.C, assertion.h: New utility.
	* Makefile (OTHER): Added it.
	* main.C (main): Register treelog.
	* all:  Use `daisy_assert' instead of `assert'.


2002-05-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.29 released.

2002-05-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C, om.h (water_factor, heat_factor): Fixed initialization
	bug. 

	* macro_std.C (height_start, height_end): Made them optional.
	(check_alist): New checks.
	* txt/tutorial.tex (subsection{Macropores}): Updated.

	* om.C (tock): Spelling fix in comment.

2002-05-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.28 released.

2002-05-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_tillage.C (ActionMixSyntax): Fix default value for
	penetration (used to be 0 for some reason). 

2002-05-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (find_abiotic): New functions.
	(tick): Use it.

2002-05-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.h, om.C (heat_factor, water_factor): New parameters.
	(heat_turnover_factor, water_turnover_factor): New member functions.

	* production.C (initialize): Added assertions.
	* organic_matter.C (add): Check that we don't add the same am twice.
	* crop_std.C (tick): Only add am pools to organic matter if
	newly created.
	* vegetation_crops.C (sow): Add error for duplicate crops.

2002-05-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/chemistry.dai: Update all parameterizations.

	* chemicals.C (canopy_update): New formula.
	* chemical_std.C (canopy_washoff_coefficient): Update dimension. 

2002-05-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* crop_std.C (harvest): Also cut back development stage for old
	crops who are low for some reason (like lack of WStem).

2002-05-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* root_system.C, root_system.h (water_uptake): New `day_fraction'
	parameter.
	* crop.h, crop_std.C, crop_simple.C, crop_old.C, crop_sold.C
	(ActualWaterUptake): Ditto.
	* vegevegetation.h, vegetation_crops.C, vegetation_permanent.C
	(transpiration): Ditto. 
	* bioclimate_std.C (WaterDistribution): Update caller.

	* root_system.C, root_system.h (water_stress_days): New state
	variable. 
	* root_system.C (water_uptake): Update it.
	* lib/log.dai ("Crop Production"): Log it.

2002-05-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.27 released.

2002-05-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* cdaisy.C, options.h: Initialize path.

	* Makefile, qmain_edit.h, qmain_edit.C, qmain.h, qmain_tree.h,
	qmain_busy.h, qmain_moc.C, qmain_populate.h, qmain_item.h,
	qmain_item.C, qmain_populate.C, qmain_edit_moc.C, qmain.C: Port to
	new Qt and GCC and GNU/Linux.

2002-05-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* geometry.C (add): New function overload.

2002-04-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("N Balance", "Carbon Balance"): Added residuals.
	* column_base.h, column_base.C (residuals_DM, residuals_N_top,
	residuals_C_top, residuals_N_soil, residuals_C_soil): New log
	variables. 
	* crop_sold.C, crop_old.C, crop_std.C, crop_simple.C, crop.h
	(harvest): Take residuals arguments.
	* harvesting.C (operator ()): Ditto.
	* vegetation_crops.C, vegetation_permanent.C, vegetation.h
	(harvest): Ditto.
	* column_base.C (harvest): Ditto.
	* production.C, production.h (tick): Ditto.
	* crop_sold.C, crop_old.C, crop_std.C, crop_simple.C, crop.h
	(tick): Ditto. 
	* vegetation_crops.C, vegetation_permanent.C, vegetation.h
	(tick): Ditto.
	* column_inorganic.C, column_std.C (tick): Ditto.
	* crop.C (kill): Ditto.
	* vegetation_crops.C, vegetation_permanent.C, vegetation.h
	(kill_all): Ditto. 


	* harvesting.C (operator ()): Add stub to residuals after
	harvest. 
	Add some mass balance checks.

2002-04-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* mactrans_std.C (tick): Allow transport of smaller quantities
	(pesticides).
	(tick): Fix BCC warning.

2002-04-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* chemicals.C, chemicals.h (canopy_dissipate, canopy_out,
	cleanup): Merged into `canopy_update'.
	* bioclimate_std.C (ChemicalDistribution): Update caller.

2002-04-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* macro_std.C (tick): Allow macropores to go below the lowest node.

2002-04-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.26 released.

2002-04-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* organic_matter.C (total_C, total_N): Fix dimensions.
	* units.C (multiply): Added entries.
	(standard_conversions): Ditto.
	* lib/log.dai ("Total Soil Content"): Added more specs.
	("Soil NO3-N Concentration"): Ditto.
	("Soil Temperature"): Ditto.
	("Soil Water Potential"): Ditto.
	("Soil Water Sink"): Ditto.

2002-04-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* geometry.C, geometry.h (initialize_zplus): New function.
	* soil.C, soil.h (initialize): New function.
	* column_base.C (initialize): Call it.
	* geometry.C (zplus): Made it optional.
	
2002-04-02  Per Abrahamsen  <abraham@dina.kvl.dk>

	* library.C (is_derived_from): Return true if a == b.

2002-03-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* units.C, units.h (get_convertion, multiply): New functions.
	* select.h, select.C, select_interval.C (default_dimension): New
	virtual member function.
	* select_value.C, select_value.h: New helper class.
	* select_number.C: Use it.
	* select_min.C: Use it.
	* select_max.C: Use it.
	* select_index.C: Use it.
	* select_flux_top.C: Use it.
	* select_flux_bottom.C: Use it.
	* select_content.C: Use it.
	* Makefile (MODELS, REMOVE): Removed select_flux.C.
	* select.C, select.h (convert): New function.
	(dimension, tag): Ditto.
	* select.C, select.h (dimension, tag): Moved parameters to impl.
	(factor, offset): Ditto.

2002-03-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* alist.C (check): New char* variant for the sake of BCC 5.0.

2002-03-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.25 released.

2002-03-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* transform_equil.C (TransformEquilibriumSyntax): Added checks.
	(TransformEquilibriumSyntax): Removed order.
	* surface.C (load_syntax): Added checks.
	* denitrification.C (load_syntax): Added checks.
	* om.C (turnover_halftime): New parameter.
	* organic_matter.C (Buffer::turnover_halftime): New parameter.
	(Buffer::load_syntax): Added range checks.
	(load_syntax): Ditto.
	* chemical_std.C (canopy_dissipation_halftime): New parameter.
	(decompose_halftime): Ditto.
	* lib/chemistry.dai (Bentazon, IPU, MCPP): Use it.

2002-03-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* chemical_soil.C, chemical.h (canopy_dissipation_rate): Dropped
	trailing coefficent.
	* chemicals.C (canopy_dissipate): Update caller.

	* chemical_soil.C (lag_increment): Moved from here.
	* chemical.h, chemical_std.C (decompose_lag_increment): Moved to here. 
	
	* txt/tutorial.tex (Defining New Pesticides): New subsubsection. 

	* chemical_std.C (ChemicalStandardSyntax): Narrow range check for
	`canopy_dissipation_rate_coefficient'. 

2002-03-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.24 released.

2002-03-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.23 released.

2002-03-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* txt: Added directory and content to cvs. 

	* average.C (description): Doc fix.
	* crop_sold.C (CropSoldSyntax): Ditto.

	* Version 2.22 released.

2002-03-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil.C, soil.h (K): Take new T argument, and use for
	manipulating water viscosity.
	* ridge.C (initialize): Update caller.
	* soil_water.C (MaxExfiltration): Update caller.
	* soil_water.C, soil_water.h (MaxExfiltration): Take new T
	argument. 
	* surface.C (tick): Update caller.
	* surface.C, surface.h (tick) Take new soil_T argument.
	* bioclimate_std.C (WaterDistribution): Update caller.
	* groundwater_pipe.C (EquilibriumDrainFlow): Update caller.
	(EquilibriumDrainFlow) Take new soil_heat argument.
	(update_water): Update caller.
	* groundwater_pipe.C, groundwater.C, groundwater.h (update_water):
	Take new soil_heat argument. 
	* soil_water.C (tick): Update caller.
	* soil_water.C, soil_water.h (tick): Take new soil_heat argument.
	* column_inorganic.C, column_std.C (tick): Update callers.
	* uzrichard.C (richard): Update caller.
	(richard): Take new soil_heat argument.
	(internode): Update caller.
	(internode): Take new soil_heat argument.
	(tick): Update caller.
	* uzrichard.C, uznone.C, uzlr.C, uzmodel.h (tick): Take new
	soil_heat argument. 
	* soil_water.C (tick): Update caller.

2002-03-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.21 released.

2002-03-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* traverse.C, traverse.h (traverse_all_submodels): New function.
	* submodel.C, submodel.h (registered): New static member function.
	* xref.C, xref.h: New utility.
	* Makefile (OTHER): Added it.
	* document.h (Document): Use it.
	* document_LaTeX.C, document.h (print_users): New function.
	* document.C (print_component): Call it.
	(print_model, print_fixed): Ditto.

2002-03-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_base.C (check): Remove duplicate declaration of ok.

	* Version 2.20 released.

2002-03-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai (AOM): Made it hourly.
	("AOM Pools", "Organic Matter"): New parameterizations.
	

	* am.C (output): Output `om' as ordered list.
	* lib/log.dai ("Total Soil Content", "N Balance") Fix users.
	(Bioincorporation, AOM, "Carbon Balance"): Ditto.

	* log.h, log.C, log_select.C, log_select.h, select.C, select.h,
	am.C: Removed Log::Maybe, open_maybe and close_maybe.
	* lib/log.dai (AOM, Bioincorporation): Fixed users.

	* log.h (open_named_entry, close_named_entry): New abstract
	virtual member functions.
	* log_select.h, log_select.C: Implemented them.
	* log_harvest.C: Ditto.
	* log_table1.C: Ditto.
	* log_alist.h, log_alist.C: Ditto.
	* log.h (NamedEntry): New member class.
	* organic_matter.C (output): Use it.
	* log.h (Entry): New member class.
	(output_list): Use it.
	* field.C (output): Use it.
	* log.h (Derived): New member class.
	(output_derived): Use it.
	* log.h (AList): New member class.
	* soil_chemicals.C (mix): Use it.
	* log.h (Geo): New member class.
	* column_base.C (output): Use it.
	* log.h (Open): New member class.
	(output_submodule, output_list, output_named, output_ordered,
	output_vector): Use it.
	* action_lisp.C (ActionCond::output): Use it..
	* cropold.C, cropsold.C (output): Use it.
	
2002-03-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.h, am.C (real_name): New function.
	* organic_matter.C (output): Use it.

	* select.h, select.C, select_array.C (prevent_printing): New
	virtual member function.
	* log_table.C (done): Use it.
	* lib/log-old.dai ("Soil Chemical"): Moved from `log.dai'.
	("Chemical"): Ditto.

	* log.h (Named, open_named, close_named, output_named): Support
	lists of named items.
	(Ordered, open_ordered, close_ordered, output_ordered): Support
	lists of ordered items.
	* soil_chemicals.C (output): Use it.
	* chemicals.C (output): Use it.
	* lib/log.dai ("Surface Chemicals", "Soil Chemicals",
	"Chemicals"): Updated.

	* Version 2.18 released.

2002-03-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (OTHER): Removed message.C

2002-03-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* treelog.C, treelog.h (message, warning, error): New virtual
	members.
	* treelog_dual.C, treelog_dual.h: New utility.
	* Makefile (OTHER): Added it.
	* main.C (main): Use it.
	* all: Take treelog argument.

2002-03-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.17 released.

2002-03-14  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Chemical"): Fix dimension.
	("Chemicals"): New parameterization.

2002-03-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_chemicals.C (find): Add to 'all'.

	* lib/chemistry.dai (solid): Obey range checks.

	* chemical_std.C (ChemicalStandardSyntax): Added range checks.

	* partition.h (Root, Leaf, Stem, RSR): Made them non-references.

	* librarian.h (Librarian, ~Librarian): Pointless change in
	handling content.

	* action_irrigate.C: Fix memory leak.

2002-03-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* library.C (~Implementation): More agressive cleanup.

	* organic_matter.C, organic_matter.h (initialize): New 'Treelog'
	argument. Use it.
	Fix SMB from SOM substraction.

	* lib/*.dai (LAIDist0): Fixed for new crops.

	* library.C (Implementation::all_count): New variable.
	(Implementation) Increment.
	(~Implementation) Decrement and delete all when zero.

	* common.h (map_delete): New template.
	* syntax.C (~Implementation): Use it.
	* soil_chemicals.C (~Implementation): Use it.
	* log_extern.C (~LogExternSource): Use it.
	* units.C (~Content): Use it.

	* log_extern.C (LogExternSource): Delete log_extern_map members.

	* root_system.C (~RootSystem): Delete rootdens.

	* svat_pmsw.C (tick): Commented out some code that used unused
	variables, and set variables not used afterwards.
	(SVAT_PMSW): Gave dummy values to some variables that are used,
	but not set.

2002-03-10  Per Abrahamsen  <abraham@dina.kvl.dk>

	* groundwater_pipe.C (RaisingGWT): Added assertions.

	* snow.C (Snow): Delete impl.
	* transform_equil.C (~TransformEquilibrium): New function.
	* equil_langmuir.C (~EquilibriumLangmuir): New function.
	* am.C (~AM): Remove bogus assertion.
	(~Implementation): Delete lock.
	* select.C (Select): Delete impl.
	(~Implementation): Delete spec.
	* field.C (Field): Delete impl.
	* soil_water.C (SoilWater): Delete reserve and bottom.
	* solute.C (Solute): Delete last_resort.

	* svat_pmsw.C (SVAT_PMSW): Initialise pstress.
	Reorder initializations.

	* librarian.h (map_create): Return value, not reference.
	(map_create_const, map_construct, map_construct_const): Ditto.
	* action_activity.C: Fix caller.
	* action_lisp.C (ActionProgn::action): Ditto.
	* action_while.C (ActionWhile::actions): Ditto.
	* action_with.C: Ditto.
	* condition_logic.C (ConditionOr::conditions): Ditto.
	(ConditionAnd::conditions): Ditto.
	* daisy.h, daisy.C (Daisy::logs): Ditto.
	(Daisy::harvest): Ditto.

	* action_lisp.C (~ActionCond, ~ActionIf): Remove CONST_DELETE
	condition. 
	* condition_logic.C (~ConditionOr, ~ConditionAnd): Ditto.

	* action_lisp.C (~ActionCond): Delete actions.
	* action_with.C (~ActionWithColumn): Delete actions.
	* column_base.C (ColumnBase): Delete transformations.
	* organic_matter.C (~Implementation): Delete am, smb, and som.
	
2002-03-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log-old.dai, lib/log.dai ("N Balance 0-100 cm"): Moved. 
	("Monthly N Balance 100 cm"): Ditto.
	("Soil Chemicals 0-100 cm"): Ditto.
	("Soil Chemical 0-100 cm"): Ditto.

	* lib/log.dai ("Soil Chemicals"): Made hourly.
	("Soil Chemical"): Ditto.

	* select_date.C (SelectDateSyntax): Fix memory leak.
	* chemicals.C (add_syntax): Ditto.
	* library.C (Library): Ditto.
	* soil_chemical.C (load_syntax): Ditto.
	* action_lisp.C (ActionLispSyntax): Ditto.
	* crop_old.C (CropOldSyntax): Ditto.
	* crop_sold.C (CropSoldSyntax): Ditto.
	* horizon.C (load_syntax): Ditto.
	* soil_NH4.C (load_syntax): Ditto.
	* soil_NO3.C (load_syntax): Ditto.
	* bioclimate_std.C (BioclimateStandardSyntax): Ditto.
	* alist.C (add): Ditto.

2002-03-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai, lib/log-old.dai ("Soil Nitrate Concentration",
	"Soil Water NO3 Concentration", "Root Zone Water Balance 0-100
	cm"): Moved. 
	* lib/log.dai ("Soil NO3 Concentration", "Soil NO3-N
	Concentration"): New parameterizations.
	("Root Zone Water Balance", "N Balance"): Made it hourly.

	* uzrichard.C (q_darcy): Cleanup error messages.

	* ridge.C (update_water): Better error message if hydraulic
	properties are not uniform within ridge.

	* Version 2.16 released.

2002-03-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* production.h, production.C (RtDR_T_factor): New parameter.

2002-03-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log-old.dai, lib/log.dai. ("Hourly Water Flux", "Daily Water
	Flux"): Moved to `log-old.dai'.
	* lib/log.dai ("Soil Temperature", "Surface Water Balance"): Made
	it hourly. 
	("Preferential Water Flux"): Store in `pref_water_flux.dlf'.  Fix
	deminesion. 
	("Matrix Water Flux"): New model.
	("Surface Water Balance"): 

	* weather_std.C (PrecipCorrect): New keyword.

	* Version 2.15 released.

2002-03-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/all.dai: New file.
	* lib/Makefile (TEXT): Added it.

2002-03-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* nitrification_soil.C (NitrificationSoilSyntax): Added range checks.
	* nitrification_solute.C (NitrificationSoluteSyntax): Ditto.

	* lib/log.dai: Changed sign for solute drainage.

2002-03-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* solute.C (tick): Added more assertions.
	(tick): Fixed bogus drainage calculation.

	* transport_cd.C (tick): Reset M when lowering timestep.

	* mactrans_std.C, mactrans.h (tick): Added `M' parameter.

	* solute.C (last_resort): Transport model if reserve fails.

	* transport_convection.C (tick): Decrease timestep if we get
	negative values.

2002-03-04  Per Abrahamsen  <abraham@dina.kvl.dk>

	* library.C, library.h (is_derived_from, base_model): New member
	functions. 
	* document.C (ModelCompare): New class.
	(print_component): Use it.
	* document_LaTeX.C (print_index): New function.
	(print_model_header): Use it.
	(print_fixed_header): Use it.
	(print_component_header): Use it.
	(print_submodel_entry): Use it.
	(print_entry_category): Don't print index here.
	* document_LaTeX.C, document.h: (print_parameterization_header(
	(print_parameterization_file) 
	(print_parameterization_no_file) 
	(print_parameterization_description) 
	(print_parameterization_trailer): New virtual functions.
	* document.C (print_model): Use them.

	* options.C (Options): Don't run simulation if we printed a manual.

	* organic_matter.C (tick): Allow zero NH4 or NO3.

2002-03-03  Per Abrahamsen  <abraham@dina.kvl.dk>

	* select.C (Spec): New member.

	* library.C, library.h (exist): New function.

	* lib/log.dai ("Total Soil Content"): Gave it a description and
	made it hourly. 

2002-03-01  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/crop-old.dai: New file..
	* lib/crop.dai: Moved old V1 crop parameterizations to
	crop/old.dai. 
	* lib/log-old.dai: New file.
	* lib/Makefile (DAISY): Added them.

	* net_radiation.C (NetRadiationSyntax): Spelling error.

	* units.C (standard_conversions): Added convertions used by
	`weather_std.C'. 
	* weather_std.C: Converted to use `units.h'.

2002-02-28  Per Abrahamsen  <abraham@dina.kvl.dk>

	* parser_file.C (get_string): Ignore escaped newlines, and let \n
	mean newline.

	* lib/maize.dai ("Pioneer Maize"): Renamed from "Maize Pioneer".

2002-02-27  Per Abrahamsen  <abraham@dina.kvl.dk>

	* action_fertilize.C (ActionFertilizeSyntax): Added range checks.

	* soil_water.C, soil_water.h (content): New function.
	* column_base.C, column_base.h, column.h (soil_water_content): New
	function. 
	* field.C, field.h (soil_water_content): New function.
	* condition_soil.C (ConditionSoilWater): New condition. 

2002-02-26  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/chemistry.dai (Pendimethalin): New chemical.

	* lib/fertilizer.dai (cattle_slurry): Updated.
	(pig_slurry): Updated.
	(cattle_manure): New.
	(pig_manure): New.
	(horse_manure): New.

	* lib/rye.dai ("Rye"): Update from hsv.
	* lib/sugarbeet.dai ("Sugar Beet"): Ditto.
	* lib/srape.dai ("Spring Rape"): Ditto.
	* lib/potato.dai: New file.
	* lib/Makefile (NEWCROPS): Added it.
	* lib/crop.dai: Input it.
	* lib/maize.dai ("Maize"): Use "Roskilde" parameterizations.
	("Maize Pioneer"): Renamed from "Maize".

2002-02-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* am.C (AM_Syntax): Use `add_fraction' for "first_year_utilization".

2002-02-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.14 released.

2002-02-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* solute.C (tick): Fix check for mass balance.

2002-02-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* solute.C (tick): Don't give mass balance errors if transported
	mass is 10 orders of magnitude smaller than total mass.

	* mactrans_std.C (tick): Fix bug that prevented macropores from
	being activated. 
	Made mass balance check work for low conetrations as well.

2002-02-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.12 released.

2002-02-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* mactrans_std.C (tick): Made it more robust.

	* production.C (tick): Substract ReMobilResp from CH2OPool.

	* Version 2.11 released.

2002-02-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* transport_cd.C: Decrease timestep if we get negative results.
	* solute.C: Added reserve transport model.
	(tick): Added checks.

2002-02-20  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic_Cosby.C (initialize): Use pow (10, x), not exp (x) for
	K_sat and h_b.

	* om.C (tick): Really fix the mass balance bug.

2002-02-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.10 released.

2002-02-19  Per Abrahamsen  <abraham@dina.kvl.dk>

	* om.C (tick): Fixed mass balance error.

	* organic_matter.C (total_N, total_C): New functions.
	(tick): Added mass balance check.

2002-02-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* macro_std.C (MacroStandardSyntax): Added checks.

	* groundwater_pipe.C (GroundwaterPipeSyntax): Added checks.

	* Version 2.09 released.

2002-02-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* harvesting.h (DSnew): Made it public.
	* harvesting.C 	(load_syntax): Made it optional.
	(operator ()): Don't set DS to DSnew here.
	(load_syntax): Added range checks to DSmax and DSnew.
	* plf.C, plf.h (inverse_safe): New function.
	* canopy_std.C, canopy_std.h (DS_at_height): New function.
	* crop_std.C (harvest): Call it.

2002-02-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* document_LaTeX.C (print_entry_category): Add index.
	* Makefile (txt/reference/reference.dvi): Ditto.
	(txt/reference/reference.pdf): Ditto.

2002-02-09  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_base.C (ColumnBase, load_syntax): Made "Bioclimate"
	optional. 

	* bioclimate_std.C (BioclimateStandardSyntax): Fix minor memory leak.

2002-02-08  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.08 released.

2002-02-07  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic.C, hydraulic.h, hydraulic_Cosby.C (initialize): Take
	clay, sand and silt parameters instead of horizon.
	* horizon.C (Horizon): Update caller.

	* transport_cd.C (tick): Only complain if the error is above mg/ha
	in the root zone.

	* parser_file.C (convert): Added support for [%].
	(check_dimension): Ditto.

	* units.C (standard_conversions): Added "[d^-1]" -> "[h^-1]"
	conversion. 

	* groundwater_pipe.C (initialize): Fix 'Treelog::Open' nesting
	bug.  
	Added some assertions.

	* vernalization.C (output): Don't output if not required (need for
	checkpoints).
	* crop_std.C (output): Ditto.

	* hydraulic_Cosby.C (check_alist): Don't complain if 'Theta_sat'
	is specified, it will be after a checkpoint.

2002-02-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.07 released.

2002-02-06  Per Abrahamsen  <abraham@dina.kvl.dk>

	* horizon.C (Implementation::hydraulic): Removed member.
	(DepolationsFactor): Take it as an argument.
	(ThermalConductivity): Update caller.
	(initialize): Update caller.

	* hydraulic_M_C.C (HydraulicM_CSyntax): Better range checking.
	* hydraulic_B_C.C (HydraulicB_CSyntax): Ditto.
	* hydraulic_mod_C.C (Hydraulic_mod_CSyntax): Ditto.

	* horizon.C (Horizon): Initialize 'hydraulic' before 'impl'.
	(~Horizon): Delete 'impl' and 'hydraulic'.

	* parser_file.C (load_list): Give error of 'directory' directive
	fails. 

2002-02-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* hydraulic.C (initialize): New virtual function.
	* horizon.C (Horizon): Call it.
	(silt, sand): New functions.
	(load_syntax): Gave SOM_C_per_N a default value (11 11).
	* hydraulic_Cosby.C: New model.
	* Makefile (MODELS): Added it.
	* horizon.C (load_syntax): Make it default.

2002-01-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.06 released.

2002-01-30  Per Abrahamsen  <abraham@dina.kvl.dk>

	* horizon.C (load_syntax): Added checks.
	* soil.C (load_syntax): Added checks.
	* geometry.C (add_layer): Added check.
	(load_syntax): Ditto.

	* lexer.h, lexer.C (Lexer::Position): New class member.
	* lexer.h, lexer.C (error): Use it.
	* parser_file.C (load_list, convert, get_number, error): Use it.


	* units.C, units.h: New utility.
	* Makefile (OTHER): Add it.
	* parser_file.C (check_dimention, convert): Use it.

2002-01-25  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.05 released.

2002-01-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* pedo_linear.C: New model.
	* Makefile (MODELS): Added it.

	* Version 2.04 released.

2002-01-24  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("N Balance"): Accumulate fixation.

2002-01-23  Per Abrahamsen  <abraham@dina.kvl.dk>

	* transform_equil.C (S_AB): New log variable.

	* soil.h, horizon.h, horizon.C (get_attribute, has_attribute): New
	member functions. 

	* mathlib.C (single_positive_root_of_square_equation): Fix error
	in caculating discriminant.

2002-01-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.03 released.

2002-01-22  Per Abrahamsen  <abraham@dina.kvl.dk>

	* lib/log.dai ("Soil Chemical"): New log model.
	("Soil Chemical 0-100 cm"): Ditto.

	* parser_file.C (check_dimention): Use ? for entries with unknown
	syntax. 

	* adsorption_full.C: New model.
	* Makefile (MODELS): Added it.
	* solute.C (check_alist): New function.
	(load_syntax): Use it.
	* lib/chemistry.dai (solid): New parameterization.

2002-01-21  Per Abrahamsen  <abraham@dina.kvl.dk>

	* equil_langmuir.C: New model.
	* Makefile (MODELS): Added it.

2002-01-18  Per Abrahamsen  <abraham@dina.kvl.dk>

	* soil_chemicals.C, soil_chemicals.h (find): New function.
	* equil.h, equil.C: New component.
	* pedo.h, pedo.C: New component.
	* Makefile (COMPONENTS): Added them.
	* transform_equil.C: New model.
	* Makefile (MODELS): Added it.

2002-01-16  Per Abrahamsen  <abraham@dina.kvl.dk>

	* transform.h, transform.C: New component.
	* column_base.h, column_base.C: Use it.
	* Makefile (COMPONENTS): Added it.

	* condition_soil.C (ConditionSoilSyntax): Fixed dimension.

	* parser_file.C (get_dimension): New function.
	(get_number): New overloaded function.
	(check_dimention): New function.
	(convert): New function.
	(load_list): Use them.

2002-01-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.02 released.

2002-01-15  Per Abrahamsen  <abraham@dina.kvl.dk>

	* column_base.C, column_base.h, column.h (daily_air_temperatur):
	New member function. 
	* field.C, field.h (daily_air_temperatur): New member function.
	* condition.h, condition.C (tick): New virtual member function.
	* condition_logic.C (ConditionOr::tick, ConditionAnd::tick,
	ConditionNot::tick, ConditionIf::tick): Define it.
	* action.h, action.C (tick): New virtual member function.
	* action_activity.C (tick): Define it.
	* action_crop.C (tick): Ditto.
	* action_lisp.C (ActionProgn::tick, ActionCond::tick,
	ActionIf::tick): Ditto.
	* action_message.C (tick): Ditto.
	* action_repeat.C (tick): Ditto.
	* action_wait.C (ActionWait::tick): Ditto.
	* action_while.C (tick): Ditto.
	* action_with.C (tick): Ditto.
	* daisy.C (tick): Call it.
	* log_checkpoint.C (match): Ditto.
	* log_select.C (match): Ditto.
	* log_table1.C (LogTable1::match, LogEntry::match): Dittto.
	* select.C (match): Ditto.
	* condition_weather.C (TSum): New model.

2001-12-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Version 2.01 released.

2001-12-12  Per Abrahamsen  <abraham@dina.kvl.dk>

	* vegetation.C (load_syntax): Don't use "\(".
	* om.C (load_syntax): Ditto.
	* bioincorporation.C (load_syntax): Ditto.

	* librarian.h (class Librarian): Use 'make_pair' instead of
	'map_type::value_type'. 

2001-12-11  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Makefile (MODELS): Added it.
	* rootdens_PLF.C: New file.

2001-12-05  Per Abrahamsen  <abraham@dina.kvl.dk>

	* Changelog.1: Renamed from Changelog.
	* Changelog: New file.
	* Makefile (TEXT): Added it.

